#include <stdlib.h>
#include <stdio.h>
#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <algorithm>
#include <string>
#include <vector>
#include <cstring>
#include <cmath>

using namespace std;


void read_BS(double B[][140]) {


	int i,j,k;
        string final1[8],temp;
	int n=182;
	
	ifstream bs_in("wse2-bi-bs");

        for(i=0;i<n;i++) {
            for(k=0;k<18;k++) {
      	       getline(bs_in,temp);
               stringstream words1(temp);
         
               if(k!=17) {
                  for(j=0;j<8;j++) {
	             words1>>final1[j];
                     B[i][k*8+j]=atof(final1[j].c_str()); 
                  }
               }
               if(k==17) {
                  for(j=0;j<4;j++) {
                     words1>>final1[j];
                     B[i][k*8+j]=atof(final1[j].c_str());
                  }
               }
            }
        }

}


void get_pos(double C[]) {


	int i,j;
	int n=182;

        C[0]=0.0;	

        for(i=0;i<n;i++) {
           if((i<=100)&&(i>0)) {
             C[i]=C[i-1]+sqrt(3.0)/100.0; // 4/5 because G-K has 80 points, while G-M 100
           }
           if((i>100)&&(i<n)) {
             C[i]=C[i-1]+2.0/80.0;
           } 
        }

}



// FUNCTION THAT READS THE Fourier components and G-vectors for POT1
void write_BS(double B[][140], double C[]) {


	int i,j;

        stringstream out_str("");
        out_str<<"bands-wse2-bi.dat";
        ofstream out_file((out_str.str()).c_str());


	for(i=101;i<182;i++) {
           out_file<<C[i]-C[181]<<"  ";
           for(j=0;j<140;j++) {
              out_file<<B[i][j]<<"  ";
           }
           out_file<<endl;
        }

        for(i=1;i<101;i++) {
           out_file<<C[i]<<"  ";
           for(j=0;j<140;j++) {
              out_file<<B[i][j]<<"  ";
           }
           out_file<<endl;
        }

        out_file.close();


}




//=======================================================================================================================================================================
// STARTING THE MAIN SCRIPT
//=======================================================================================================================================================================


int main(int argc, char *argv[]) {

   int iter1,iter2,iter3,iter4;

   double B[182][140];
   double C[182];


   read_BS(B);
   get_pos(C);
   write_BS(B,C);

return 0;
			
}

